-- joskin
-- extends trailer.lua
-- by yekk1

joskin = {};

function joskin:new(configFile, positionX, offsetY, positionZ, rotationY, customMt)

    if joskin_mt == nil then
        joskin_mt = Class(joskin, Trailer);
    end;

    local mt = customMt;
    if mt == nil then
        mt = joskin_mt;
    end;
    local instance = Trailer:new(configFile, positionX, offsetY, positionZ, rotationY, mt);

    local xmlFile = loadXMLFile("TempConfig", configFile);

	

	instance.trailingTruckBackAngle = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailingTruck#backAngle"), 25);
	instance.trailingTruckActive = true;

	instance.isActive = false;
	
    delete(xmlFile);

    return instance;
end;

function joskin:delete()
    Trailer.delete(self);
end;

function joskin:mouseEvent(posX, posY, isDown, isUp, button)
    Trailer.mouseEvent(self, posX, posY, isDown, isUp, button);
end;

function joskin:keyEvent(unicode, sym, modifier, isDown)
    Trailer.keyEvent(self, unicode, sym, modifier, isDown);
	if isDown and sym == Input.KEY_k then
		self.trailingTruckActive = not self.trailingTruckActive;
	end;

end;

function joskin:update(dt)
	Trailer.update(self, dt);

	if g_currentMission.currentVehicle ~= nil then
		if g_currentMission.currentVehicle.attachedTrailer == self then
			
			local angle = 0;
			local backAngle = 0;
			
			if self.trailingTruckActive then	
				g_currentMission:addExtraPrintText("Taste K: Lenkachse ausschalten");
			else
				g_currentMission:addExtraPrintText("Taste K: Lenkachse einschalten");
			end;
			
			
			if self.trailingTruckActive then
				local x1,y1,z1 = localDirectionToWorld(self.attacherVehicle.rootNode, 0, 0, 1)
				local x2,y2,z2 = localDirectionToWorld(self.rootNode, 0, 0, 1)

				local dot = x1*x2 + z1*z2;
				dot = dot / (Utils.vector2Length(x1,z1) * Utils.vector2Length(x2,z2))

				angle = math.acos(dot);
				
	            local cy = z1 * x2 - x1 * z2;
	            
	            if cy < 0 then
	                angle = -angle;
	            end;
				backAngle  = self.trailingTruckBackAngle * (angle / 50);				
			end;			
			
			for i=1, table.getn(self.wheels) do
		        local x,y,z = getRotation(self.wheels[i].repr);			
				local newX, newY, newZ = getWheelShapePosition(self.wheels[i].node, self.wheels[i].wheelShape);
				setTranslation(self.wheels[i].repr, newX, newY, newZ);
				local axleSpeed = getWheelShapeAxleSpeed(self.wheels[i].node, self.wheels[i].wheelShape)*3.14159/180;
				x = x+axleSpeed*dt/1000.0;
				if i == 2 or i == 4 then
					setWheelShapeProps(self.wheels[i].node, self.wheels[i].wheelShape, 0, 0, backAngle);
					setRotation(self.wheels[i].repr, x, backAngle, z);					
				else
					steeringAngle = 0;
					setRotation(self.wheels[i].repr, x, steeringAngle, z);
				end;
		    end;
			
			
			
		end;
	end;
    

    
end;

